/* Problem URL: https://codeforces.com/edu/course/2/lesson/4/4/practice/contest/274684/problem/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

using mat = array<array<int, 2>, 2>;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int r, n, m;
    cin >> r >> n >> m;

    V<mat> fds(n);

    rep(i, n) {
        rep(j, 2) {
            rep(k, 2) {
                cin >> fds[i][j][k];
            }
        }
    }

    const mat identity = {{{1, 0}, {0, 1}}};

    while (__builtin_popcount(n) != 1) {
        n++;
        fds.emplace_back(identity);
    }

    auto mul = [&](mat &a, mat &b, mat &ans) {
        ans[0][0] = (a[0][0] * b[0][0] + a[0][1] * b[1][0]) % r;
        ans[1][0] = (a[1][0] * b[0][0] + a[1][1] * b[1][0]) % r;
        ans[0][1] = (a[0][0] * b[0][1] + a[0][1] * b[1][1]) % r;
        ans[1][1] = (a[1][0] * b[0][1] + a[1][1] * b[1][1]) % r;
    };

    V<mat> seg(n * 2);

    nrep(i, n, n * 2) {
        seg[i] = fds[i - n];
    }

    for (int i = n - 1; i > 0; i--) {
        mul(seg[i * 2], seg[i * 2 + 1], seg[i]);
    }

    function<void(int, int, int, int, int, mat&)> query = [&](int i, int l, int r, int tl, int tr, mat &ans) {
        if (l > tr || r < tl) {
            ans = identity;
            return;
        }

        if (l >= tl && r <= tr) {
            ans = seg[i];
            return;
        }

        int mid = (l + r) >> 1;

        mat ans1;
        mat ans2;

        query(i * 2, l, mid, tl, tr, ans1);
        query(i * 2 + 1, mid + 1, r, tl, tr, ans2);

        mul(ans1, ans2, ans);
    };

    while (m--) {
        int l, r;
        cin >> l >> r;

        l--, r--;

        mat res;
        query(1, 0, n - 1, l, r, res);

        rep(i, 2) {
            rep(j, 2) {
                cout << res[i][j] << ' ';
            }
            cout << '\n';
        }

        if (m > 0) {
            cout << '\n';
        }
    }
}
